<template>
  <div class="branch">
    <el-form
      :inline="true"
      :model="dataForm"
      @keyup.enter.native="getDataList()">
      <el-form-item>
        <el-input
          v-model="dataForm.key"
          placeholder="用户名／用户操作"
          clearable
        ></el-input>
      </el-form-item>
      <el-form-item>
        <el-button @click="getDataList()">查询</el-button>
      </el-form-item>
      <el-form-item>
        <el-button v-if="isAuth('sys:role:save')" type="primary" @click="addOrUpdateHandle()">新增</el-button>
      </el-form-item>
      <el-form-item>
        <el-button v-if="isAuth('sys:role:delete')" type="danger" @click="deleteHandle()" :disabled="selectionDataList.length <= 0">批量删除</el-button>
      </el-form-item>
    </el-form>
    <el-table
      :data="dataList"
      @selection-change="selectionChangeHandle"
      v-loading="dataListLoading"
      style="width: 100%">
      <el-table-column
        type="selection"
        header-align="center"
        align="center"
        width="50">
      </el-table-column>
      <el-table-column
        prop="name"
        header-align="center"
        align="center"
        label="养殖员姓名">
      </el-table-column>
      <el-table-column
        prop="position"
        header-align="center"
        align="center"
        label="职位">
      </el-table-column>
      <el-table-column
        prop="approachTime"
        header-align="center"
        align="center"
        label="入场时间">
      </el-table-column>
      <el-table-column
        prop="departureTime"
        header-align="center"
        align="center"
        label="离场时间">
      </el-table-column>
      <el-table-column
        header-align="center"
        align="center"
        label="当前在岗">
        <template slot-scope="scope">
          {{scope.row.jobStatus? '是': '否'}}
        </template>
      </el-table-column>
      <el-table-column
        fixed="right"
        header-align="center"
        align="center"
        label="操作">
        <template slot-scope="scope">
          <el-button v-if="isAuth('sys:user:update')" type="text" size="small" @click="addOrUpdateHandle(scope.row)">修改</el-button>
          <el-button v-if="isAuth('sys:user:delete')" type="text" size="small" @click="deleteHandle(scope.row.id)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-dialog
      :title="!form.id ? '新增' : '修改'"
      :close-on-click-modal="false"
      :visible.sync="visible"
      @close="cancel">
      <el-form :model="form" ref="form" @keyup.enter.native="formSubmit()" label-width="80px">
        <el-form-item label="姓名">
         <el-input v-model="form.name" placeholder="养殖员姓名"></el-input>
        </el-form-item>
        <el-form-item label="职位">
          <el-input v-model="form.position" placeholder="职位"></el-input>
        </el-form-item>
        <el-form-item label="当前在岗">
          <el-select v-model="form.jobStatus" placeholder="请选择当前是否在岗">
            <el-option
              v-for="item in options"
              :key="item.value"
              :label="item.label"
              :value="item.value">
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="入场时间">
          <el-date-picker
            v-model="form.approachTime"
            type="datetime"
            value-format="yyyy-MM-dd HH:mm:ss"
            placeholder="选择日期时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="离场时间">
          <el-date-picker
            v-model="form.departureTime"
            type="datetime"
            value-format="yyyy-MM-dd HH:mm:ss"
            placeholder="选择日期时间">
          </el-date-picker>
        </el-form-item>
      </el-form>
      <span slot="footer" class="dialog-footer">
        <el-button @click="cancel">取消</el-button>
        <el-button type="primary" @click="formSubmit()">确定</el-button>
      </span>
    </el-dialog>
  </div>
</template>
<script>
export default {
  data () {
    return {
      dataForm: {
        key: ''
      },
      dataList: [
        {
          buildTime: '',
          id: '',
          location: '',
          manager: '',
          name: '',
        }
      ],
      pageIndex: 1,
      pageSize: 10,
      totalPage: 0,
      dataListLoading: false,
      selectionDataList: [],
      visible: false,
      form: {
        id: '',
        name: '',
        position: '',
        approachTime: '',
        departureTime: '',
        jobStatus: ''
      },
      options: [
        {
          value: true,
          label: '是'
        },
        {
          value: false,
          label: '否'
        }
      ],
      pigs: []
    }
  },
  created () {
    this.getDataList()
  },
  mounted () {
    // this.getCascader()
  },
  methods: {
    // 获取数据列表
    getDataList () {
      this.dataListLoading = true
      this.$http({
        url: this.$http.adornUrl('/management/employee/list'),
        method: 'post',
        params: this.$http.adornParams({
          page: 1,
          limit: 10,
          keywords: this.dataForm.key
        })
      }).then(({ data }) => {
        console.log(data);
        if (data && data.code === 0) {
          this.dataList = data.page.list
          this.totalPage = data.page.totalCount
        } else {
          this.dataList = []
          this.totalPage = 0
          this.$confirm(`查询养殖员信息失败`, '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }).then(() => {
            return
          }).catch(() => {})
        }
        this.dataListLoading = false
      })
    },
    // 每页数
    sizeChangeHandle (val) {
      this.pageSize = val
      this.pageIndex = 1
      this.getDataList()
    },
    // 当前页
    currentChangeHandle (val) {
      this.pageIndex = val
      this.getDataList()
    },
    // 新增 or 修改谱系信息
    addOrUpdateHandle (row) {
      // 显示谱系新增 or 修改面板
      this.visible = true
      if (row) {
        this.form = row
      }
    },
    // 选择n个养殖员
    selectionChangeHandle (val) {
      this.selectionDataList = []
      val.forEach(item => {
        this.selectionDataList.push(item.id)
      });
    },
    // 删除n个养殖员
    deleteHandle (id) {
      this.$confirm(`确定删除养殖员信息？`, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        // 删除操作
        if (id) {
          this.selectionDataList.push(id)
        }
        if (this.selectionDataList.length <= 0) {
          return
        }
        this.$http({
          url: this.$http.adornUrl('/management/employee/delete'),
          method: 'post',
          data: this.$http.adornData(this.selectionDataList, false)
        }).then(result => {
          if (result.data.code === 0) {
            this.$message({
              message: '成功删除养殖员信息',
              type: 'success',
              duration: 1000
            })
          } else {
            this.$message.error('删除养殖员信息失败');
          }
          this.resetForm()
          this.selectionDataList = []
        })
      }).catch(() => {})
    },
    formSubmit () {
      if (this.form.id) {
        // 修改
        if (this.confirmInput()) {
          // 检查入场时间、立场时间、当前在岗
          if (!this.confirmJobStatus()) {
            return
          }
          // 进行修改操作
          this.$http({
            url: this.$http.adornUrl('/management/employee/update'),
            method: 'post',
            data: this.$http.adornData({
              id: this.form.id,
              position: this.form.position,
              approachTime: this.form.approachTime,
              departureTime: this.form.departureTime,
              jobStatus: this.form.jobStatus
            })
          }).then(result => {
            if (result.data.code === 0) {
              this.resetForm();
              this.visible = false;
              this.$message({
                message: '成功修改养殖员信息',
                type: 'success',
                duration: 1000
              })
            } else {
              this.$message.error('修改养殖员信息失败');
            }
          })
        } else {
          // 请输入完整
          this.$confirm(`请输入完整`, '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }).then(() => {
            return
          }).catch(() => {})
        }
      } else {
        // 新增
        if (this.confirmInput(1)) {
          // 检查入场时间、立场时间、当前在岗
          if (!this.confirmJobStatus()) {
            return
          }
          // 进行新增操作
          this.$http({
            url: this.$http.adornUrl('/management/employee/save'),
            method: 'post',
            data: this.$http.adornData({
              name: this.form.name,
              position: this.form.position,
              approachTime: this.form.approachTime,
              departureTime: this.form.departureTime,
              jobStatus: this.form.jobStatus
            })
          }).then(result => {
            if (result.data.code === 0) {
              this.resetForm();
              this.visible = false;
              this.$message({
                message: '成功添加养殖员信息',
                type: 'success',
                duration: 1000
              })
            } else {
              this.$message.error('添加养殖员信息失败');
            }
          })
        } else {
          // 请输入完整
          this.$confirm(`请输入完整`, '提示', {
            confirmButtonText: '确定',
            cancelButtonText: '取消',
            type: 'warning'
          }).then(() => {
            return
          }).catch(() => {})
        }
      }
    },
    // 判断新增/修改时是否输入完整
    confirmInput (val) {
      val && (delete this.form.id, delete this.form.deleted, delete this.form.gmtCreate, delete this.form.gmtModified)
      for (let i in this.form) {
        if (!this.form[i].toString()) {
          return false
        }
      }
      return true
    },
    // 清空form
    resetForm () {
      for (let i in this.form) {
        this.form[i] = ''
      }
      this.getDataList()
    },
    // 取消
    cancel () {
      this.visible = false
      this.resetForm()
    },
    // 判断当前在岗是否正确
    getJobStatus () {
      let start = new Date(this.form.approachTime)
      let end = new Date(this.form.departureTime)
      let now = new Date()
      if (start <= now && now <= end) {
        return 1
      } else if (start < end) {
        return 2
      }
      return 0
    },
    // 判断当前在岗与入场时间、离场时间是否有冲突
    confirmJobStatus () {
      if ((this.getJobStatus() === 1  && this.form.jobStatus) || (this.getJobStatus() === 2  && !this.form.jobStatus)) {
        return true
      }
      this.$confirm(`请检查当前在岗、入场时间与离场时间`, '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        // return false
        console.log('新增养殖员有误');
      }).catch(() => {})
      return false
    }
  }
}
</script>
<style scoped>
</style>